<script setup lang="ts">
import { computed } from "vue";
import ShowcaseTitleInput from "./ShowcaseTitleInput.vue";
import type { MaterialIconName } from "./components/MaterialIcon";

const props = defineProps<{
  id: string;
  labelText: string;
  placeholder: string;
  error?: boolean;
  disabled?: boolean;
  helperText?: string;
  startIcon?: MaterialIconName;
  endIcon?: MaterialIconName;
  modelValue?: string;
  small?: boolean;
  fullwidth?: boolean;
  multiline?: boolean;
  rows?: number;
}>();

const emit = defineEmits<{
  (e: "update:id", value: string): void;
  (e: "update:labelText", value: string): void;
  (e: "update:placeholder", value: string): void;
  (e: "update:helperText", value: string): void;
  (e: "update:startIcon", value: string): void;
  (e: "update:endIcon", value: string): void;
  (e: "update:modelValue", value: string): void;
  (e: "update:rows", value: number): void;
}>();

const valueId = computed({
  get() {
    return props.id;
  },
  set(value: string) {
    emit("update:id", value);
  },
});

const valueLabelText = computed({
  get() {
    return props.labelText;
  },
  set(value: string) {
    emit("update:labelText", value);
  },
});

const valuePlaceholder = computed({
  get() {
    return props.placeholder;
  },
  set(value: string) {
    emit("update:placeholder", value);
  },
});

const valueHelperText = computed({
  get() {
    return props.helperText || "";
  },
  set(value: string) {
    emit("update:helperText", value);
  },
});

const valueStartIcon = computed({
  get() {
    return props.startIcon || "";
  },
  set(value: string) {
    emit("update:startIcon", value);
  },
});

const valueEndIcon = computed({
  get() {
    return props.endIcon || "";
  },
  set(value: string) {
    emit("update:endIcon", value);
  },
});

const valueModelValue = computed({
  get() {
    return props.modelValue || "";
  },
  set(value: string) {
    emit("update:modelValue", value);
  },
});

const valueRows = computed({
  get() {
    return (props.rows || 1).toString();
  },
  set(value: string) {
    const parsedInt = parseInt(value);
    emit("update:rows", parsedInt && parsedInt > 1 ? parsedInt : 1);
  },
});
</script>

<template>
  <h2>
    &lt;LabeledInput :attributes="{
    <span class="no-line-break">
      id: <ShowcaseTitleInput class="input" v-model="valueId" />'</span
    >,
    <span class="no-line-break">
      labelText: '<ShowcaseTitleInput
        class="input"
        v-model="valueLabelText"
      />'</span
    >,
    <span class="no-line-break"
      >placeholder: '<ShowcaseTitleInput
        class="input"
        v-model="valuePlaceholder"
      />'</span
    >
    <template v-if="error"
      >, <span class="no-line-break">error: true</span></template
    >
    <template v-if="disabled"
      >, <span class="no-line-break">disabled: true</span></template
    >
    <template v-if="helperText != undefined"
      >,
      <span class="no-line-break"
        >helperText: '<ShowcaseTitleInput
          class="input"
          v-model="valueHelperText"
        />'
      </span></template
    >
    <template v-if="startIcon != undefined"
      >,
      <span class="no-line-break">
        startIcon: '<ShowcaseTitleInput
          class="input"
          v-model="valueStartIcon"
        />'
      </span></template
    >
    <template v-if="endIcon != undefined"
      >,
      <span class="no-line-break">
        endIcon: '<ShowcaseTitleInput class="input" v-model="valueEndIcon" />'
      </span></template
    >
    <template v-if="modelValue != undefined"
      >,
      <span class="no-line-break">
        modelValue: '<ShowcaseTitleInput
          class="input"
          v-model="valueModelValue"
        />'
      </span></template
    >
    <template v-if="small"
      >, <span class="no-line-break">small: true</span></template
    >
    <template v-if="fullwidth"
      >, <span class="no-line-break">fullwidth: true</span></template
    >
    <template v-if="multiline"
      >, <span class="no-line-break">multiline: true</span></template
    >
    <template v-if="rows != undefined"
      >,
      <span class="no-line-break">
        rows: '<ShowcaseTitleInput class="input" v-model="valueRows" />'
      </span></template
    >
    }"/&gt;
  </h2>
</template>

<style lang="scss">
.no-line-break {
  white-space: nowrap;
}

.input {
  font: inherit;
  display: inline;
  border: none;
  width: max-content;

  &:focus {
    outline: none;
  }
}
</style>
